## com.google.gwt.user.client.ui
Class TextArea

    java.lang.Object
      com.google.gwt.user.client.ui.UIObject
          com.google.gwt.user.client.ui.Widget
              com.google.gwt.user.client.ui.FocusWidget
                  com.google.gwt.user.client.ui.TextBoxBase
                      com.google.gwt.user.client.ui.TextArea

All Implemented Interfaces:
  HasAllFocusHandlers, HasAllKeyHandlers, HasAllMouseHandlers, HasBlurHandlers, HasChangeHandlers, HasClickHandlers, HasFocusHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasValueChangeHandlers<java.lang.String>, HasHandlers, HasDirection, EventListener, Focusable, HasFocus, HasName, HasText, HasValue<java.lang.String>, SourcesChangeEvents, SourcesClickEvents, SourcesFocusEvents, SourcesKeyboardEvents, SourcesMouseEvents

    public class TextArea

extends TextBoxBase
implements HasDirection

A text box that allows multiple lines of text to be entered.

### CSS Style Rules

- .gwt-TextArea { primary style }
- .gwt-TextArea-readonly { dependent style set when the text area is read-only }

### Example

>     public class TextBoxExample implements EntryPoint {

>       public void onModuleLoad() {
>         // Make some text boxes. The password text box is identical to the text
>         // box, except that the input is visually masked by the browser.
>         PasswordTextBox ptb = new PasswordTextBox();
>         TextBox tb = new TextBox();

>         // TODO(ECC) must be tested.
>         tb.addKeyPressHandler(new KeyPressHandler() {

>           public void onKeyPress(KeyPressEvent event) {
>             if (!Character.isDigit(event.getCharCode())) {
>               ((TextBox) event.getSource()).cancelKey();
>             }
>           }
>         });

>         // Let's make an 80x50 text area to go along with the other two.
>         TextArea ta = new TextArea();
>         ta.setCharacterWidth(80);
>         ta.setVisibleLines(50);

>         // Add them to the root panel.
>         VerticalPanel panel = new VerticalPanel();
>         panel.add(tb);
>         panel.add(ptb);
>         panel.add(ta);
>         RootPanel.get().add(panel);
>       }
>     }

Nested Class Summary

Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.TextBoxBase
`TextBoxBase.TextAlignConstant`

Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject
`UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

Nested classes/interfaces inherited from interface com.google.gwt.i18n.client.HasDirection
`HasDirection.Direction`

Field Summary

Fields inherited from class com.google.gwt.user.client.ui.TextBoxBase
`ALIGN_CENTER, ALIGN_JUSTIFY, ALIGN_LEFT, ALIGN_RIGHT`

Fields inherited from class com.google.gwt.user.client.ui.UIObject
`DEBUG_ID_PREFIX`

Constructor Summary
`` | `TextArea()` Creates an empty text area.
`protected` | `TextArea(Element element)` This constructor may be used by subclasses to explicitly use an existing element.

Method Summary
`int` | `getCharacterWidth()` Gets the requested width of the text box (this is not an exact value, as not all characters are created equal).
`int` | `getCursorPos()` Gets the current position of the cursor (this also serves as the beginning of the text selection).
`HasDirection.Direction` | `getDirection()` Gets the directionality of the widget.
`int` | `getSelectionLength()` Gets the length of the current text selection.
`int` | `getVisibleLines()` Gets the number of text lines that are visible.
`void` | `setCharacterWidth(int width)` Sets the requested width of the text box (this is not an exact value, as not all characters are created equal).
`void` | `setDirection(HasDirection.Direction direction)` Sets the directionality for a widget.
`void` | `setVisibleLines(int lines)` Sets the number of text lines that are visible.
`static TextArea` | `wrap(Element element)` Creates a TextArea widget that wraps an existing <textarea> element.

Methods inherited from class com.google.gwt.user.client.ui.TextBoxBase
`addChangeHandler, addChangeListener, addValueChangeHandler, cancelKey, getImpl, getName, getSelectedText, getText, getValue, isReadOnly, onBrowserEvent, removeChangeListener, selectAll, setCursorPos, setKey, setName, setReadOnly, setSelectionRange, setText, setTextAlignment, setValue, setValue`

Methods inherited from class com.google.gwt.user.client.ui.FocusWidget

`addBlurHandler, addClickHandler, addClickListener, addFocusHandler, addFocusListener, addKeyboardListener, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addMouseDownHandler, addMouseListener, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMouseWheelHandler, addMouseWheelListener, getFocusImpl, getTabIndex, isEnabled, removeClickListener, removeFocusListener, removeKeyboardListener, removeMouseListener, removeMouseWheelListener, setAccessKey, setElement, setEnabled, setFocus, setTabIndex`

Methods inherited from class com.google.gwt.user.client.ui.Widget
`addDomHandler, addHandler, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getHandlerCount, getParent, isAttached, isOrWasAttached, onAttach, onDetach, onLoad, onUnload, removeFromParent, sinkEvents`

Methods inherited from class com.google.gwt.user.client.ui.UIObject

`addStyleDependentName, addStyleName, ensureDebugId, ensureDebugId, ensureDebugId, getAbsoluteLeft, getAbsoluteTop, getElement, getOffsetHeight, getOffsetWidth, getStyleElement, getStyleName, getStyleName, getStylePrimaryName, getStylePrimaryName, getTitle, isVisible, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, setElement, setHeight, setPixelSize, setSize, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setTitle, setVisible, setVisible, setWidth, toString, unsinkEvents`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### TextArea

    public TextArea()

  Creates an empty text area.

### TextArea

    protected TextArea(Element element)

  This constructor may be used by subclasses to explicitly use an existing element. This element must be a <textarea> element.

  Parameters:
    `element` - the element to be used

Method Detail

### wrap

    public static TextArea wrap(Element element)

  Creates a TextArea widget that wraps an existing <textarea> element. This element must already be attached to the document. If the element is removed from the document, you must call `RootPanel.detachNow(Widget)`.

  Parameters:
    `element` - the element to be wrapped

### getCharacterWidth

    public int getCharacterWidth()

  Gets the requested width of the text box (this is not an exact value, as not all characters are created equal).

  Returns:
    the requested width, in characters

### getCursorPos

    public int getCursorPos()

  Description copied from class: `TextBoxBase`
  Gets the current position of the cursor (this also serves as the beginning of the text selection).

  Overrides:
    `getCursorPos` in class `TextBoxBase`
  Returns:
    the cursor's position

### getDirection

    public HasDirection.Direction getDirection()

  Description copied from interface: `HasDirection`
  Gets the directionality of the widget.

  Specified by:
    `getDirection` in interface `HasDirection`
  Returns:
    `RTL` if the directionality is right-to-left, `LTR` if the directionality is left-to-right, or `DEFAULT` if the directionality is not explicitly specified

### getSelectionLength

    public int getSelectionLength()

  Description copied from class: `TextBoxBase`
  Gets the length of the current text selection.

  Overrides:
    `getSelectionLength` in class `TextBoxBase`
  Returns:
    the text selection length

### getVisibleLines

    public int getVisibleLines()

  Gets the number of text lines that are visible.

  Returns:
    the number of visible lines

### setCharacterWidth

    public void setCharacterWidth(int width)

  Sets the requested width of the text box (this is not an exact value, as not all characters are created equal).

  Parameters:
    `width` - the requested width, in characters

### setDirection

    public void setDirection(HasDirection.Direction direction)

  Description copied from interface: `HasDirection`
  Sets the directionality for a widget.

  Specified by:
    `setDirection` in interface `HasDirection`
  Parameters:
    `direction` - `RTL` if the directionality should be set to right-to-left, `LTR` if the directionality should be set to left-to-right `DEFAULT` if the directionality should not be explicitly set

### setVisibleLines

    public void setVisibleLines(int lines)

  Sets the number of text lines that are visible.

  Parameters:
    `lines` - the number of visible lines